<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch">
      <el-form-item label="礼品名称" prop="giftName">
        <el-input
          v-model="queryParams.giftName"
          placeholder="请输入礼品名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <!--<el-form-item label="启用标志" prop="qybz">-->
      <!--  <el-select v-model="queryParams.qybz" placeholder="请选择启用标志" clearable size="small">-->
      <!--    <el-option-->
      <!--      v-for="dict in dict.type.sys_yes_no"-->
      <!--      :key="dict.value"-->
      <!--      :label="dict.label"-->
      <!--      :value="dict.value"-->
      <!--    />-->
      <!--  </el-select>-->
      <!--</el-form-item>-->
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['canteen:gift:add']"
        >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['canteen:gift:edit']"
        >修改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['canteen:gift:remove']"
        >删除
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['canteen:gift:export']"
        >导出
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-edit"
          size="mini"
          :loading="exportLoading"
          @click="noticeShow"
        >兑换公告
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <div style="padding: 5px">
          <el-switch
            @change="setNoticeStatus"
            v-model="noticeForm.openStatus"
            active-text="打开公告"
            inactive-text="关闭公告">
          </el-switch>
        </div>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="giftList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="礼品id" align="center" prop="giftId" v-if="false"/>
      <el-table-column label="礼品编号" align="center" prop="giftNumber"/>
      <el-table-column label="礼品名称" align="center" prop="giftName"/>
      <el-table-column label="礼品图片" align="center" prop="giftPictrue">
        <template slot-scope="scope">
          <img style="width:80px;height:80px;border:none;" :src="baseUrl + scope.row.giftPictrue">
        </template>
      </el-table-column>
      <el-table-column label="礼品价格" align="center" prop="giftPrice"/>
      <el-table-column label="库存数量" align="center" prop="amount"/>
      <el-table-column label="启用标志" align="center" prop="qybz">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.sys_normal_disable" :value="scope.row.qybz"/>
        </template>
      </el-table-column>
      <!--      <el-table-column label="机构代码" align="center" prop="orgCode">-->
      <!--        <template slot-scope="scope">-->
      <!--          <div v-for="item in orgList">-->
      <!--            <el-tag v-if="item.orgCode === scope.row.orgCode">-->
      <!--              {{ item.orgName }}-->
      <!--            </el-tag>-->
      <!--          </div>-->
      <!--        </template>-->
      <!--      </el-table-column>-->
      <el-table-column label="备注" align="center" prop="remark"/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['canteen:gift:edit']"
          >修改
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['canteen:gift:remove']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改礼品登记对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules">
        <el-form-item label="礼品名称" prop="giftName">
          <el-input v-model="form.giftName" placeholder="请输入礼品名称"/>
        </el-form-item>
        <el-form-item label="礼品图片" prop="giftPictrue">
          <imageUpload v-model="form.giftPictrue"/>
        </el-form-item>
        <el-form-item label="礼品价格" prop="giftPrice">
          <el-input v-model="form.giftPrice" placeholder="请输入礼品价格"/>
        </el-form-item>
        <el-form-item label="库存数量" prop="amount">
          <el-input v-model="form.amount" placeholder="请输入库存数量"/>
        </el-form-item>
        <el-form-item label="启用标志" prop="qybz">
          <el-select v-model="form.qybz" placeholder="请选择启用标志">
            <el-option
              v-for="dict in dict.type.sys_normal_disable"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="礼品类型" prop="giftType">
          <treeselect v-model="form.giftType" :options="giftTypeOptions" :normalizer="normalizer"
                      placeholder="请选择礼品类型"/>
        </el-form-item>
        <!--        <el-form-item label="机构代码" prop="orgCode">-->
        <!--          <el-select v-model="form.jgid" placeholder="请选择机构代码">-->
        <!--            <el-option-->
        <!--              v-for="item in orgList"-->
        <!--              :key="item.orgCode"-->
        <!--              :label="item.orgName"-->
        <!--              :value="item.orgCode"-->
        <!--            ></el-option>-->
        <!--          </el-select>-->
        <!--        </el-form-item>-->
        <el-form-item label="详情内容" prop="remark">
          <editor v-model="form.giftContent" :min-height="192"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 添加或修改礼品登记对话框 -->
    <el-dialog title="设置公告" :visible.sync="noticeForm.open" width="600px" append-to-body>
      <el-input v-model="noticeForm.text" placeholder="请输入公告"/>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="updateNotice()" v-prevent-re-click>确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listGift,
  getGift,
  delGift,
  addGift,
  updateGift,
  exportGift,
  getNotice,
  notice,
  getNoticeStatus,
  setNoticeStatus
} from '@/api/canteen/gift'
import { getMasterOrgInfos } from '@/api/master-api'
import { listGiftType } from '@/api/canteen/giftType'
import eventConfig from '@/views/eventConfig/event'
import Treeselect from '@riophae/vue-treeselect'
import '@riophae/vue-treeselect/dist/vue-treeselect.css'
import { submitBindingRelation } from '@/api/eventConfig/relation'

export default {
  name: 'Gift',
  dicts: ['sys_normal_disable'],
  components: {
    Treeselect, eventConfig
  },
  data() {
    return {
      baseUrl: process.env.VUE_APP_BASE_API,
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 礼品登记表格数据
      giftList: [],
      orgList: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      noticeForm: {
        open: false,
        text: '',
        openStatus: false
      },
      eventForm: {
        open: false,
        text: '',
        openStatus: false
      },
      eventGiftForm: {
        eventId: '',
        eventBusinessIds: [],
        businessType: '1',
        open: false,
        text: '',
        openStatus: false
      },
      // 礼品类型树选项
      giftTypeOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        giftName: null,
        giftEventType: '2',
        qybz: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        giftName: [
          { required: true, message: '礼品名称不能为空', trigger: 'blur' }
        ],
        qybz: [
          { required: true, message: '启用标志 0-启用 1-禁用不能为空', trigger: 'change' }
        ]
      }
    }
  },
  created() {
    this.getList()
    this.getNotice()
    this.getNoticeStatus()
  },
  methods: {
    bindingGift() {
      this.eventGiftForm.open = true
      setTimeout(() => {
        this.eventGiftForm.eventId = this.$refs.event.getEventId()
      }, 100)
    },
    submitBindingEventGifts() {
      submitBindingRelation(this.eventGiftForm).then(re => {
        if (re.code === 200) {
          this.$modal.msgSuccess('绑定成功')
        }
      })
    },
    setNoticeStatus() {
      let data = {
        'openStatus': this.noticeForm.openStatus ? 'true' : 'false'
      }
      setNoticeStatus(data).then(re => {
        this.getNoticeStatus()
        this.$modal.msgSuccess('更新成功')
      })
    },
    getNoticeStatus() {
      getNoticeStatus().then(re => {
        this.noticeForm.openStatus = re.msg !== 'false'
      })
    },
    getNotice() {
      getNotice().then(re => {
        this.noticeForm.text = re.msg
      })
    },
    updateNotice() {
      let params = {
        'text': this.noticeForm.text
      }
      notice(params).then(re => {
        this.$modal.msgSuccess('修改成功')
        this.getNotice()
        this.noticeForm.open = false
      })
    },
    /** 查询礼品登记列表 */
    getList() {
      this.loading = true
      getMasterOrgInfos().then(response => {
        this.orgList = response.data
      })
      listGift(this.queryParams).then(response => {
        this.giftList = response.rows
        this.giftList.forEach(item => {
          item.orgCode = item.jgid
        })
        this.total = response.total
        this.loading = false
      })
    },
    /** 查询礼品类型下拉树结构 */
    getTreeselect() {
      listGiftType().then(response => {
        this.giftTypeOptions = []
        const data = { id: 0, giftTypeName: '顶级分类', children: [] }
        data.children = this.handleTree(response.data, 'id', 'parentId')
        this.giftTypeOptions.push(data)
      })
    },
    /** 转换礼品类型数据结构 */
    normalizer(node) {
      if (node.children && !node.children.length) {
        delete node.children
      }
      return {
        id: node.id,
        label: node.giftTypeName,
        children: node.children
      }
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.noticeForm.open = false
      this.eventGiftForm.open = false
      this.noticeForm.text = ''
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {
        giftId: null,
        giftNumber: null,
        giftName: null,
        giftPictrue: null,
        giftPrice: null,
        amount: null,
        qybz: null,
        jgid: null,
        isDelete: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null
      }
      this.resetForm('form')
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.giftId)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    // 多选框选中数据
    handleSelectionChange2(selection) {
      this.eventGiftForm.eventBusinessIds = selection.map(item => item.giftId)
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.getTreeselect()
      this.reset()
      this.open = true
      this.title = '添加礼品登记'
      this.form.giftEventType = '2'
    },
    noticeShow() {
      this.noticeForm.open = true
    },
    eventShow() {
      this.eventForm.open = true
      setTimeout(() => {
        this.$refs.event.queryParams.eventType = '1'
        this.$refs.event.getList()
      }, 100)
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.getTreeselect()
      this.reset()
      const giftId = row.giftId || this.ids
      getGift(giftId).then(response => {
        this.form = response.data
        this.form.giftEventType = '2'
        this.open = true
        this.title = '修改礼品登记'
      })
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs['form'].validate(valid => {
        if (valid) {
          if (this.form.giftId != null) {
            updateGift(this.form).then(response => {
              this.$modal.msgSuccess('修改成功')
              this.open = false
              this.getList()
            })
          } else {
            addGift(this.form).then(response => {
              this.$modal.msgSuccess('新增成功')
              this.open = false
              this.getList()
            })
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const giftIds = row.giftId || this.ids
      this.$modal.confirm('是否确认删除礼品登记编号为"' + giftIds + '"的数据项？').then(function() {
        return delGift(giftIds)
      }).then(() => {
        this.getList()
        this.$modal.msgSuccess('删除成功')
      }).catch(() => {
      })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams
      this.$modal.confirm('是否确认导出所有礼品登记数据项？').then(() => {
        this.exportLoading = true
        return exportGift(queryParams)
      }).then(response => {
        this.$download.name(response.msg)
        this.exportLoading = false
      }).catch(() => {
      })
    }
  }
}
</script>
